#include <iostream>
#include <vector>

using namespace std;

struct Input {
    vector<double> numbers;
    size_t bin_count{};
};
Input
input_data(){
    size_t number_count, bin_count;
	cerr << "Enter number count: ";
    cin >> number_count;
    Input in;
    in.numbers.resize(number_count);
    for (size_t i = 0; i < number_count; i++)
    {
        cerr << "Enter Num[" << i << "]: ";
        cin >> in.numbers[i];
    }
    cerr << "Enter bin count: "; cin >> bin_count;
    cerr << "Enter bin count: ";
    cin >> in.bin_count;
    return in;
}

void find_minmax(const vector<double> &numbers, double &min, double &max){
    min = numbers[0];
    max = numbers[0];
    for(double number : numbers)
    {
        if(number < min)
        {
            min = number;
        }
        if(number > max)
        {
            max = number;
        }
    }
    return;
}
vector<size_t> make_histogram (vector<double> numbers, size_t bin_count){
    double min;
    double max;
    find_minmax (numbers, min, max);
    double bin_size = (max - min) / bin_count;
    vector<size_t> bins(bin_count);
    for (size_t i = 0; i < numbers.size(); i++)
    {
        bool found = false;
        for(size_t j = 0; (j < (bin_count - 1)) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count-1]++;
        }
    }
    return bins;
}
void show_histogram_text(vector<size_t> bins, size_t bin_count){
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

    size_t max_bin = bins[0];
    for(size_t i = 0; i < bin_count; i++)
    {
        if(bins[i] > max_bin)
        {
            max_bin = bins[i];
        }
    }

    for (size_t bin: bins)
    {
        size_t height = bin;

        if (max_bin > MAX_ASTERISK)
        {
          height = MAX_ASTERISK * (static_cast<double>(bin) / max_bin);
        }

        if (bin < 100)
        {
            cout << ' ';
        }
        if (bin < 10)
        {
            cout << ' ';
        }
        cout << bin << "|";
        for(size_t i = 0; i < height; i++)
        {
            cout << "*";
        }
        cout << endl;
    }
}
int main()
{
    auto in = input_data();
    auto bins = make_histogram(in.numbers, in.bin_count);
    show_histogram_text(bins, in.bin_count);

    return 0;

}
